import processing.video.*;

Capture cam;

void setup() {
  size(640, 360);

  String[] cameras = Capture.list();
  
  if (cameras.length == 0) {
    println("There are no cameras available for capture.");
    exit();
  } else {
    println("Available cameras:");
    for (int i = 0; i < cameras.length; i++) {
      println(cameras[i]);
    }
    
    // The camera can be initialized directly using an 
    // element from the array returned by list():
    //Capture(parent, requestWidth, requestHeight, cameraName, frameRate)
    cam = new Capture(this, 640, 360, cameras[0], 30);
    cam.start();     
  }      
}

void draw() {
  if (cam.available() == true) {
    cam.read();
  }
        //creamos una variable para determinar el tamaño de los cuadrados
    int salto = 8;
    //Declaramos una variable del tipo de datos color (un objeto color, para ser estrictos)
    color theColor;
    //realizamos un doble loop para recorrer los píxels:
    for (int i=0; i<cam.width; i+=salto) {
      for (int j=0; j<cam.height; j+=salto) {
        //y asignamos a theColor, con foto.get(), el color EN EL VÍDEO del punto donde estamos
        theColor = cam.get(i, j);
        //preparamos el fill() con el color del pixel donde estamos
        fill(theColor);
        //y dibujamos un rect en el punto en que estamos del color sobre el que estamos en el video
        //(sin random seria: 
        rect(i, j, salto, salto);
        //con un random para hacerlo saltar
        //rect(i+random(-salto,salto),j+random(-salto,salto),salto,salto);
      }
    }
    println(frameRate);
}
