import processing.video.*;

Capture cam;
//declaramos el color a buscar
color trackColor;
//y declaramos sus valores de color
float trackRed,trackGreen,trackBlue;

void setup() {
  size(640, 360);

  String[] cameras = Capture.list();
  
  if (cameras.length == 0) {
    println("There are no cameras available for capture.");
    exit();
  } else {
    println("Available cameras:");
    for (int i = 0; i < cameras.length; i++) {
      println(cameras[i]);
    }
    
    // The camera can be initialized directly using an 
    // element from the array returned by list():
    //Capture(parent, requestWidth, requestHeight, cameraName, frameRate)
    cam = new Capture(this, 640, 360, cameras[0], 30);
    cam.start();     
  }      
}

void draw() {
  if (cam.available() == true) {
    cam.read();
  }
  image(cam, 0,0);
  //creamos las variables para guardar el valor más próximo al color buscado (proximidad y posición)
  float recordDist= 1000;
  int recordX=0;
  int recordY=0;
  //doble loop para hacer la operación para todos los píxels
  for(int x=0; x<cam.width; x++){
    for(int y=0; y<cam.height; y++){
      //leemos el color del píxel
      color c = cam.get(x,y);
      //calculamos su distancia al color que buscamos
      float distanciaColors = dist(red(c),green(c),blue(c),trackRed,trackGreen,trackBlue);
      //si la distancia es menor a la que tenemos guardada como récord (la menor hasta ahora)
      if (distanciaColors <= recordDist) {
        //guardamos el valor de dicha distancia
        recordDist = distanciaColors;
        //su posicion en el eje X
        recordX = x;
        //y su posicion en el eje Y
        recordY = y;
      }//fin del condicional
    }
  }//fin del doble loop
  //Dibujamos una elipse en el punto en cuestión
  ellipse(recordX,recordY,30,30);
  //println(framerate);// para comprobar framerate
}

//función que se ejecuta al clicar con el mouse
void mousePressed(){
  //guardamos los valores de color del píxel donde hemos clicado
  trackColor = get(mouseX,mouseY);
  trackRed=red(trackColor);
  trackGreen=green(trackColor);
  trackBlue=blue(trackColor);
  println("r:"+trackRed+"g:"+trackGreen+"b:"+trackBlue);
}
