import processing.video.*;

Capture cam;
//declaremos la variable umbral
int umbral=10000;
//Y declaramos un array para guardar el fondo
color pixelsFons[][];


void setup() {
  size(640, 360);

  String[] cameras = Capture.list();
  
  if (cameras.length == 0) {
    println("There are no cameras available for capture.");
    exit();
  } else {
    println("Available cameras:");
    for (int i = 0; i < cameras.length; i++) {
      println(cameras[i]);
    }
    
    // The camera can be initialized directly using an 
    // element from the array returned by list():
    //Capture(parent, requestWidth, requestHeight, cameraName, frameRate)
    cam = new Capture(this, 640, 360, cameras[0], 30);
    cam.start();     
  }      
      //inicializamos el array que contendrá los colores del fondo
  pixelsFons = new color[width][height];
  grabaElFons();
}

void draw() {
  if (cam.available() == true) {
    cam.read();
  }
     //dibujamos el fondo
    background(0);
    //esto sirve para cargar en memória los datos de color que analizaremos
    cam.loadPixels();
    loadPixels();
    //cambiamos el umbral de tolerancia según la posicion del mouse
    umbral = mouseX;

    //doble loop para que la operación se repita para todos los píxels
    for (int x=0; x<cam.width; x++) {
      for (int y=0; y<cam.height; y++) {

        color c = cam.get(x,y);
        color fons =  pixelsFons[x][y];
        
        
        //calculamos la distancia entre el color de fondo y el del píxel actual
        float distanciaColors = dist(red(c), green(c), blue(c), red(fons), green(fons), blue(fons));
        //si la sistancia es mayor al umbral
        if (distanciaColors > umbral) {
          //dibujamos este píxel en rojo
          set(x, y, color(255, 0, 0));
        }
      }
    }
}

//función que se ejecuta al clicar con el mouse
void mousePressed() {
  grabaElFons();
  println(umbral);
}

//funcion para grabar el fotograma que hay en un momento determinado:
void grabaElFons() {
  //creamos el doble loop
  for (int x=0; x<cam.width; x++) {
    for (int y=0; y<cam.height; y++) {
      //guardamos el color del píxel en cuestión
      color c = cam.get(x,y);//mov.pixels[pos];
      pixelsFons[x][y]=c;
    }
  }
}
